diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/wifi-mac.cc ns-3.45/src/wifi/model/wifi-mac.cc
--- ns-3.44/src/wifi/model/wifi-mac.cc	2025-03-09 16:55:49.803372600 -0700
+++ ns-3.45/src/wifi/model/wifi-mac.cc	2025-06-01 20:34:45.628702200 -0700
@@ -376,10 +376,10 @@
                 MakeTraceSourceAccessor(&WifiMac::m_psduMapResponseTimeoutCallback),
                 "ns3::WifiMac::PsduMapResponseTimeoutCallback")
             .AddTraceSource("IcfDropReason",
-                            "An ICF is dropped by an EMLSR client for the given reason on the "
-                            "link with the given ID. This trace source is actually fed by the "
-                            "EHT Frame Exchange Manager through the m_icfDropCallback member "
-                            "variable.",
+                            "An ICF sent by the given sender is dropped by an EMLSR client for "
+                            "the given reason on the link with the given ID. This trace source "
+                            "is actually fed by the EHT Frame Exchange Manager through the "
+                            "m_icfDropCallback member variable.",
                             MakeTraceSourceAccessor(&WifiMac::m_icfDropCallback),
                             "ns3::WifiMac::IcfDropCallback");
     return tid;
@@ -1572,7 +1572,7 @@
 
 void
 WifiMac::BlockUnicastTxOnLinks(WifiQueueBlockedReason reason,
-                               const Mac48Address& address,
+                               Mac48Address address,
                                const std::set<uint8_t>& linkIds)
 {
     std::stringstream ss;
@@ -1586,9 +1586,9 @@
     for (const auto linkId : linkIds)
     {
         auto& link = GetLink(linkId);
-        auto linkAddr = link.stationManager->GetAffiliatedStaAddress(address).value_or(address);
+        auto linkAddr = link.stationManager->GetAffiliatedStaAddress(address);
 
-        if (link.stationManager->GetMldAddress(address) == address && linkAddr == address)
+        if (link.stationManager->GetMldAddress(address) == address && !linkAddr.has_value())
         {
             NS_LOG_DEBUG("Link " << +linkId << " has not been setup with the MLD, skip");
             continue;
@@ -1601,14 +1601,14 @@
                                      acIndex,
                                      {WIFI_QOSDATA_QUEUE, WIFI_CTL_QUEUE},
                                      address,
-                                     GetAddress(),
+                                     GetLocalAddress(address),
                                      {ac.GetLowTid(), ac.GetHighTid()},
                                      {linkId});
             // block queues storing management and control frames that use link addresses
             m_scheduler->BlockQueues(reason,
                                      acIndex,
                                      {WIFI_MGT_QUEUE, WIFI_CTL_QUEUE},
-                                     linkAddr,
+                                     linkAddr.value_or(address),
                                      link.feManager->GetAddress(),
                                      {},
                                      {linkId});
@@ -1618,7 +1618,7 @@
 
 void
 WifiMac::UnblockUnicastTxOnLinks(WifiQueueBlockedReason reason,
-                                 const Mac48Address& address,
+                                 Mac48Address address,
                                  const std::set<uint8_t>& linkIds)
 {
     NS_ASSERT(m_scheduler);
@@ -1639,9 +1639,9 @@
     for (const auto linkId : shuffledLinkIds)
     {
         auto& link = GetLink(linkId);
-        auto linkAddr = link.stationManager->GetAffiliatedStaAddress(address).value_or(address);
+        auto linkAddr = link.stationManager->GetAffiliatedStaAddress(address);
 
-        if (link.stationManager->GetMldAddress(address) == address && linkAddr == address)
+        if (link.stationManager->GetMldAddress(address) == address && !linkAddr.has_value())
         {
             NS_LOG_DEBUG("Link " << +linkId << " has not been setup with the MLD, skip");
             continue;
@@ -1657,14 +1657,14 @@
                                        acIndex,
                                        {WIFI_QOSDATA_QUEUE, WIFI_CTL_QUEUE},
                                        address,
-                                       GetAddress(),
+                                       GetLocalAddress(address),
                                        {ac.GetLowTid(), ac.GetHighTid()},
                                        {linkId});
             // unblock queues storing management and control frames that use link addresses
             m_scheduler->UnblockQueues(reason,
                                        acIndex,
                                        {WIFI_MGT_QUEUE, WIFI_CTL_QUEUE},
-                                       linkAddr,
+                                       linkAddr.value_or(address),
                                        link.feManager->GetAddress(),
                                        {},
                                        {linkId});
@@ -1884,14 +1884,14 @@
             return m_address;
         }
     }
-    // we get here if no ML setup was established between this device and the remote device,
-    // i.e., they are not both multi-link devices
+    // we get here if no ML setup was established between this device and the remote device
     if (GetNLinks() == 1)
     {
         // this is a single link device
         return m_address;
     }
-    // this is an MLD (hence the remote device is single link or unknown)
+    // this is an MLD which performed legacy association with the remote device or the remote device
+    // is unknown
     return DoGetLocalAddress(remoteAddr);
 }
 
@@ -2205,10 +2205,11 @@
     HtCapabilities capabilities;
 
     auto phy = GetWifiPhy(linkId);
-    Ptr<HtConfiguration> htConfiguration = GetHtConfiguration();
+    auto htConfiguration = GetHtConfiguration();
     bool sgiSupported = htConfiguration->m_sgiSupported;
     capabilities.SetLdpc(htConfiguration->m_ldpcSupported);
-    capabilities.SetSupportedChannelWidth(htConfiguration->m_40MHzSupported ? 1 : 0);
+    const auto width = phy->GetChannelWidth();
+    capabilities.SetSupportedChannelWidth((width < MHz_u{40}) ? 0 : 1);
     capabilities.SetShortGuardInterval20(sgiSupported);
     capabilities.SetShortGuardInterval40(sgiSupported);
     // Set Maximum A-MSDU Length subfield
@@ -2237,9 +2238,7 @@
         uint8_t nss = (mcs.GetMcsValue() / 8) + 1;
         NS_ASSERT(nss > 0 && nss < 5);
         uint64_t dataRate =
-            mcs.GetDataRate(htConfiguration->m_40MHzSupported ? MHz_u{40} : MHz_u{20},
-                            NanoSeconds(sgiSupported ? 400 : 800),
-                            nss);
+            mcs.GetDataRate(std::min(width, MHz_u{40}), NanoSeconds(sgiSupported ? 400 : 800), nss);
         if (dataRate > maxSupportedRate)
         {
             maxSupportedRate = dataRate;
@@ -2264,12 +2263,10 @@
     VhtCapabilities capabilities;
 
     auto phy = GetWifiPhy(linkId);
-    Ptr<HtConfiguration> htConfiguration = GetHtConfiguration();
-    NS_ABORT_MSG_IF(!htConfiguration->m_40MHzSupported,
-                    "VHT stations have to support 40 MHz operation");
-    Ptr<VhtConfiguration> vhtConfiguration = GetVhtConfiguration();
-    bool sgiSupported = htConfiguration->m_sgiSupported;
-    capabilities.SetSupportedChannelWidthSet(vhtConfiguration->m_160MHzSupported ? 1 : 0);
+    auto htConfiguration = GetHtConfiguration();
+    const auto sgiSupported = htConfiguration->m_sgiSupported;
+    const auto width = phy->GetChannelWidth();
+    capabilities.SetSupportedChannelWidthSet((width < MHz_u{160}) ? 0 : 1);
     // Set Maximum MPDU Length subfield
     uint16_t maxAmsduSize =
         std::max({m_voMaxAmsduSize, m_viMaxAmsduSize, m_beMaxAmsduSize, m_bkMaxAmsduSize});
@@ -2313,16 +2310,15 @@
         capabilities.SetTxMcsMap(maxMcs, nss);
     }
     uint64_t maxSupportedRateLGI = 0; // in bit/s
-    const auto maxWidth = vhtConfiguration->m_160MHzSupported ? MHz_u{160} : MHz_u{80};
     for (const auto& mcs : phy->GetMcsList(WIFI_MOD_CLASS_VHT))
     {
-        if (!mcs.IsAllowed(maxWidth, 1))
+        if (!mcs.IsAllowed(width, 1))
         {
             continue;
         }
-        if (mcs.GetDataRate(maxWidth) > maxSupportedRateLGI)
+        if (mcs.GetDataRate(width) > maxSupportedRateLGI)
         {
-            maxSupportedRateLGI = mcs.GetDataRate(maxWidth);
+            maxSupportedRateLGI = mcs.GetDataRate(width);
             NS_LOG_DEBUG("Updating maxSupportedRateLGI to " << maxSupportedRateLGI);
         }
     }
@@ -2343,24 +2339,32 @@
     NS_ASSERT(GetHeSupported());
     HeCapabilities capabilities;
 
-    Ptr<WifiPhy> phy = GetLink(linkId).phy;
-    Ptr<HtConfiguration> htConfiguration = GetHtConfiguration();
-    Ptr<VhtConfiguration> vhtConfiguration = GetVhtConfiguration();
-    Ptr<HeConfiguration> heConfiguration = GetHeConfiguration();
+    auto phy = GetLink(linkId).phy;
+    auto htConfiguration = GetHtConfiguration();
+    auto heConfiguration = GetHeConfiguration();
     uint8_t channelWidthSet = 0;
-    if ((htConfiguration->m_40MHzSupported) && (phy->GetPhyBand() == WIFI_PHY_BAND_2_4GHZ))
+    const auto width = phy->GetChannelWidth();
+    if (const auto band = phy->GetPhyBand(); band == WIFI_PHY_BAND_2_4GHZ)
     {
-        channelWidthSet |= 0x01;
-    }
-    // we assume that HE stations support 80 MHz operations
-    if ((phy->GetPhyBand() == WIFI_PHY_BAND_5GHZ) || (phy->GetPhyBand() == WIFI_PHY_BAND_6GHZ))
-    {
-        channelWidthSet |= 0x02;
+        if (width >= MHz_u{40})
+        {
+            channelWidthSet |= 0x01;
+        }
     }
-    if ((vhtConfiguration->m_160MHzSupported) &&
-        ((phy->GetPhyBand() == WIFI_PHY_BAND_5GHZ) || (phy->GetPhyBand() == WIFI_PHY_BAND_6GHZ)))
+    else if (band == WIFI_PHY_BAND_5GHZ || band == WIFI_PHY_BAND_6GHZ)
     {
-        channelWidthSet |= 0x04;
+        if (width >= MHz_u{40})
+        {
+            channelWidthSet |= 0x02;
+        }
+        if (width >= MHz_u{160})
+        {
+            channelWidthSet |= 0x04;
+            if (phy->GetOperatingChannel().GetNSegments() > 1)
+            {
+                channelWidthSet |= 0x08;
+            }
+        }
     }
     capabilities.SetChannelWidthSet(channelWidthSet);
     capabilities.SetLdpcCodingInPayload(htConfiguration->m_ldpcSupported);
@@ -2465,15 +2469,16 @@
     capabilities.SetMaxAmpduLength(std::min(std::max(maxAmpduLength, 8388607U), 16777215U));
 
     // Set the PHY capabilities
-    const bool support4096Qam = phy->IsMcsSupported(WIFI_MOD_CLASS_EHT, 12);
+    const auto support4096Qam = phy->IsMcsSupported(WIFI_MOD_CLASS_EHT, 12);
     capabilities.m_phyCapabilities.supportTx1024And4096QamForRuSmallerThan242Tones =
         support4096Qam ? 1 : 0;
     capabilities.m_phyCapabilities.supportRx1024And4096QamForRuSmallerThan242Tones =
         support4096Qam ? 1 : 0;
 
-    const uint8_t maxTxNss = phy->GetMaxSupportedTxSpatialStreams();
-    const uint8_t maxRxNss = phy->GetMaxSupportedRxSpatialStreams();
-    if (auto htConfig = GetHtConfiguration(); !htConfig->m_40MHzSupported)
+    const auto maxTxNss = phy->GetMaxSupportedTxSpatialStreams();
+    const auto maxRxNss = phy->GetMaxSupportedRxSpatialStreams();
+    const auto width = phy->GetChannelWidth();
+    if (width == MHz_u{20})
     {
         for (auto maxMcs : {7, 9, 11, 13})
         {
@@ -2501,7 +2506,7 @@
                 phy->IsMcsSupported(WIFI_MOD_CLASS_EHT, maxMcs) ? maxTxNss : 0);
         }
     }
-    if (auto vhtConfig = GetVhtConfiguration(); vhtConfig->m_160MHzSupported)
+    if (width >= MHz_u{160})
     {
         for (auto maxMcs : {9, 11, 13})
         {
@@ -2515,8 +2520,21 @@
                 phy->IsMcsSupported(WIFI_MOD_CLASS_EHT, maxMcs) ? maxTxNss : 0);
         }
     }
-    // 320 MHz not supported yet
-
+    if (width >= MHz_u{320})
+    {
+        capabilities.m_phyCapabilities.support320MhzIn6Ghz = true;
+        for (auto maxMcs : {9, 11, 13})
+        {
+            capabilities.SetSupportedRxEhtMcsAndNss(
+                EhtMcsAndNssSet::EHT_MCS_MAP_TYPE_320_MHZ,
+                maxMcs,
+                phy->IsMcsSupported(WIFI_MOD_CLASS_EHT, maxMcs) ? maxRxNss : 0);
+            capabilities.SetSupportedTxEhtMcsAndNss(
+                EhtMcsAndNssSet::EHT_MCS_MAP_TYPE_320_MHZ,
+                maxMcs,
+                phy->IsMcsSupported(WIFI_MOD_CLASS_EHT, maxMcs) ? maxTxNss : 0);
+        }
+    }
     return capabilities;
 }
 
@@ -2585,4 +2603,91 @@
     return m_robustAVStreamingSupported;
 }
 
+void
+WifiMac::RecordCapabilities(const MgtFrameType& frame, const Mac48Address& from, uint8_t linkId)
+{
+    NS_LOG_FUNCTION(this << frame.index() << from << linkId);
+    auto remoteStationManager = GetWifiRemoteStationManager(linkId);
+    auto phy = GetWifiPhy(linkId);
+
+    // lambda processing Information Elements included in all frame types
+    auto recordFromIes = [&](auto&& frame) {
+        NS_ASSERT(frame.template Get<SupportedRates>());
+        const auto rates = AllSupportedRates{*frame.template Get<SupportedRates>(),
+                                             frame.template Get<ExtendedSupportedRatesIE>()};
+        for (const auto& mode : phy->GetModeList())
+        {
+            if (rates.IsSupportedRate(mode.GetDataRate(phy->GetChannelWidth())))
+            {
+                remoteStationManager->AddSupportedMode(from, mode);
+                if (rates.IsBasicRate(mode.GetDataRate(phy->GetChannelWidth())))
+                {
+                    remoteStationManager->AddBasicMode(mode);
+                }
+            }
+        }
+
+        // we do not return if HT is not supported because HE STAs operating in
+        // the 6 GHz band do not support VHT
+        if (GetHtSupported(linkId))
+        {
+            /* HT station */
+            if (const auto& htCapabilities = frame.template Get<HtCapabilities>())
+            {
+                remoteStationManager->AddStationHtCapabilities(from, *htCapabilities);
+            }
+            if (const auto& extendedCapabilities = frame.template Get<ExtendedCapabilities>())
+            {
+                remoteStationManager->AddStationExtendedCapabilities(from, *extendedCapabilities);
+            }
+        }
+
+        // we do not return if VHT is not supported because HE STAs operating in
+        // the 2.4 GHz or 6 GHz band do not support VHT
+        if (GetVhtSupported(linkId))
+        {
+            const auto& vhtCapabilities = frame.template Get<VhtCapabilities>();
+            // we will always fill in RxHighestSupportedLgiDataRate field at TX, so this can be used
+            // to check whether it supports VHT
+            if (vhtCapabilities.has_value() &&
+                vhtCapabilities->GetRxHighestSupportedLgiDataRate() > 0)
+            {
+                remoteStationManager->AddStationVhtCapabilities(from, *vhtCapabilities);
+            }
+        }
+
+        if (!GetHeSupported())
+        {
+            return;
+        }
+
+        const auto& heCapabilities = frame.template Get<HeCapabilities>();
+        if (heCapabilities.has_value() && heCapabilities->GetSupportedMcsAndNss() != 0)
+        {
+            remoteStationManager->AddStationHeCapabilities(from, *heCapabilities);
+        }
+
+        if (Is6GhzBand(linkId))
+        {
+            if (const auto& he6GhzCapabilities = frame.template Get<He6GhzBandCapabilities>())
+            {
+                remoteStationManager->AddStationHe6GhzCapabilities(from, *he6GhzCapabilities);
+            }
+        }
+
+        if (!GetEhtSupported())
+        {
+            return;
+        }
+
+        if (const auto& ehtCapabilities = frame.template Get<EhtCapabilities>())
+        {
+            remoteStationManager->AddStationEhtCapabilities(from, *ehtCapabilities);
+        }
+    };
+
+    // process Information Elements included in the current frame variant
+    std::visit(recordFromIes, frame);
+}
+
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/wifi-mac.h ns-3.45/src/wifi/model/wifi-mac.h
--- ns-3.44/src/wifi/model/wifi-mac.h	2025-03-09 16:55:49.803372600 -0700
+++ ns-3.45/src/wifi/model/wifi-mac.h	2025-06-01 20:34:45.628702200 -0700
@@ -102,6 +102,10 @@
     WifiMac(const WifiMac&) = delete;
     WifiMac& operator=(const WifiMac&) = delete;
 
+    /// type of the management frames
+    using MgtFrameType =
+        std::variant<MgtBeaconHeader, MgtProbeResponseHeader, MgtAssocResponseHeader>;
+
     /**
      * Assign a fixed random variable stream number to the random variables
      * used by this model.  Return the number of streams (possibly zero) that
@@ -337,7 +341,7 @@
      * @param linkIds the IDs of the links to block
      */
     void BlockUnicastTxOnLinks(WifiQueueBlockedReason reason,
-                               const Mac48Address& address,
+                               Mac48Address address,
                                const std::set<uint8_t>& linkIds);
 
     /**
@@ -350,7 +354,7 @@
      * @param linkIds the IDs of the links to unblock
      */
     void UnblockUnicastTxOnLinks(WifiQueueBlockedReason reason,
-                                 const Mac48Address& address,
+                                 Mac48Address address,
                                  const std::set<uint8_t>& linkIds);
 
     /**
@@ -811,6 +815,24 @@
                          uint8_t tid,
                          uint8_t linkId) const;
 
+    /// Information reported by ICF drop trace
+    struct IcfDropInfo
+    {
+        WifiIcfDrop reason{}; ///< the reason why the ICF was dropped by the EMLSR client
+        uint8_t linkId{};     ///< the ID of the link on which the ICF was dropped
+        Mac48Address sender;  ///< the sender of the ICF
+    };
+
+    /**
+     * TracedCallback signature for ICF drop events.
+     *
+     * @param info information reported by ICF drop trace
+     */
+    typedef void (*IcfDropCallback)(const IcfDropInfo& info);
+
+    /// TracedCallback for ICF drop events typedef
+    using IcfDropTracedCallback = TracedCallback<const IcfDropInfo&>;
+
   protected:
     void DoInitialize() override;
     void DoDispose() override;
@@ -965,6 +987,17 @@
                                 WifiDirection dir,
                                 const WifiTidLinkMapping& mapping);
 
+    /**
+     * Update capabilities information from the given management frame.
+     *
+     * @param frame the body of the given management frame
+     * @param addr MAC address of the sender
+     * @param linkId ID of the link the management frame was received over
+     */
+    void RecordCapabilities(const MgtFrameType& frame, const Mac48Address& addr, uint8_t linkId);
+
+    UniformRandomBitGenerator m_shuffleLinkIdsGen; //!< random number generator to shuffle link IDs
+
     Ptr<MacRxMiddle> m_rxMiddle; //!< RX middle (defragmentation etc.)
     Ptr<MacTxMiddle> m_txMiddle; //!< TX middle (aggregation etc.)
     Ptr<Txop> m_txop;            //!< TXOP used for transmission of frames to non-QoS peers.
@@ -1244,8 +1277,6 @@
     uint16_t m_mpduBufferSize;  //!< BlockAck buffer size (in number of MPDUs)
     uint32_t m_frameRetryLimit; //!< the frame retry limit
 
-    UniformRandomBitGenerator m_shuffleLinkIdsGen; //!< random number generator to shuffle link IDs
-
     bool m_robustAVStreamingSupported; ///< flag whether robust AV streaming is supported
 
     /// @brief DL TID-to-Link Mapping negotiated with an MLD (identified by its MLD address)
@@ -1380,17 +1411,6 @@
      */
     PsduMapResponseTimeoutTracedCallback m_psduMapResponseTimeoutCallback;
 
-    /**
-     * TracedCallback signature for ICF drop events.
-     *
-     * @param reason the reason why the ICF was dropped by the EMLSR client
-     * @param linkId the ID of the link on which the ICF was dropped
-     */
-    typedef void (*IcfDropCallback)(WifiIcfDrop reason, uint8_t linkId);
-
-    /// TracedCallback for ICF drop events typedef
-    using IcfDropTracedCallback = TracedCallback<WifiIcfDrop, uint8_t>;
-
     IcfDropTracedCallback m_icfDropCallback; //!< traced callback for ICF drop events
 };
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/wifi-mac-header.cc ns-3.45/src/wifi/model/wifi-mac-header.cc
--- ns-3.44/src/wifi/model/wifi-mac-header.cc	2025-03-09 16:55:49.799372700 -0700
+++ ns-3.45/src/wifi/model/wifi-mac-header.cc	2025-06-01 20:34:45.627702200 -0700
@@ -787,6 +787,16 @@
     return MicroSeconds(m_duration);
 }
 
+bool
+WifiMacHeader::HasNav() const
+{
+    // When the contents of a received Duration/ID field, treated as an unsigned integer,
+    // are greater than 32 768, the contents are interpreted as appropriate for the frame
+    // type and subtype or ignored if the receiving MAC entity does not have a defined
+    // interpretation for that type and subtype (IEEE 802.11-2016 sec. 10.27.3)
+    return (GetRawDuration() & 0x8000) == 0;
+}
+
 uint16_t
 WifiMacHeader::GetSequenceControl() const
 {
@@ -1184,6 +1194,8 @@
         break;
     case WIFI_MAC_CTL_BACKREQ:
     case WIFI_MAC_CTL_BACKRESP:
+        os << "RA=" << m_addr1 << ", TA=" << m_addr2 << ", Duration/ID=" << m_duration << "us";
+        break;
     case WIFI_MAC_CTL_CTLWRAPPER:
     case WIFI_MAC_CTL_END:
     case WIFI_MAC_CTL_END_ACK:
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/wifi-mac-header.h ns-3.45/src/wifi/model/wifi-mac-header.h
--- ns-3.44/src/wifi/model/wifi-mac-header.h	2025-03-09 16:55:49.799372700 -0700
+++ ns-3.45/src/wifi/model/wifi-mac-header.h	2025-06-01 20:34:45.627702200 -0700
@@ -512,6 +512,12 @@
      * @return the duration from the Duration/ID field (Time object)
      */
     Time GetDuration() const;
+
+    /**
+     * @return true if the Duration/ID field contains a value for setting the NAV
+     */
+    bool HasNav() const;
+
     /**
      * Return the raw Sequence Control field.
      *
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/wifi-mac-queue-scheduler.h ns-3.45/src/wifi/model/wifi-mac-queue-scheduler.h
--- ns-3.44/src/wifi/model/wifi-mac-queue-scheduler.h	2025-03-09 16:55:49.799372700 -0700
+++ ns-3.45/src/wifi/model/wifi-mac-queue-scheduler.h	2025-06-01 20:34:45.627702200 -0700
@@ -175,6 +175,36 @@
                                const std::set<uint8_t>& tids = {},
                                const std::set<uint8_t>& linkIds = {}) = 0;
 
+    /**
+     * Block the given set of links for all the container queues for the given reason.
+     *
+     * @param reason the reason for blocking the queues
+     * @param linkIds set of links to block (empty to block all setup links)
+     */
+    virtual void BlockAllQueues(WifiQueueBlockedReason reason,
+                                const std::set<uint8_t>& linkIds = {}) = 0;
+
+    /**
+     * Unblock the given set of links for all the container queues for the given reason.
+     *
+     * @param reason the reason for unblocking the queues
+     * @param linkIds set of links to unblock (empty to unblock all setup links)
+     */
+    virtual void UnblockAllQueues(WifiQueueBlockedReason reason,
+                                  const std::set<uint8_t>& linkIds = {}) = 0;
+
+    /**
+     * Return whether all the container queues are blocked for the given link for the given
+     * reason, if different than REASONS_COUNT, or for any reason, otherwise.
+     *
+     * @param linkId the ID of the given link
+     * @param reason the reason to check (if different than REASONS_COUNT)
+     * @return whether all the container queues are blocked for the given link
+     */
+    virtual bool GetAllQueuesBlockedOnLink(
+        uint8_t linkId,
+        WifiQueueBlockedReason reason = WifiQueueBlockedReason::REASONS_COUNT) = 0;
+
     /// Bitset identifying the reasons to block individual links for a container queue
     using Mask = std::bitset<static_cast<std::size_t>(WifiQueueBlockedReason::REASONS_COUNT)>;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/wifi-mac-queue-scheduler-impl.h ns-3.45/src/wifi/model/wifi-mac-queue-scheduler-impl.h
--- ns-3.44/src/wifi/model/wifi-mac-queue-scheduler-impl.h	2025-03-09 16:55:49.799372700 -0700
+++ ns-3.45/src/wifi/model/wifi-mac-queue-scheduler-impl.h	2025-06-01 20:34:45.627702200 -0700
@@ -87,6 +87,12 @@
                        const Mac48Address& txAddress,
                        const std::set<uint8_t>& tids,
                        const std::set<uint8_t>& linkIds) final;
+    /** @copydoc ns3::WifiMacQueueScheduler::BlockAllQueues */
+    void BlockAllQueues(WifiQueueBlockedReason reason, const std::set<uint8_t>& linkIds) final;
+    /** @copydoc ns3::WifiMacQueueScheduler::UnblockAllQueues */
+    void UnblockAllQueues(WifiQueueBlockedReason reason, const std::set<uint8_t>& linkIds) final;
+    /** @copydoc ns3::WifiMacQueueScheduler::GetAllQueuesBlockedOnLink */
+    bool GetAllQueuesBlockedOnLink(uint8_t linkId, WifiQueueBlockedReason reason) final;
     /** @copydoc ns3::WifiMacQueueScheduler::GetQueueLinkMask */
     std::optional<Mask> GetQueueLinkMask(AcIndex ac,
                                          const WifiContainerQueueId& queueId,
@@ -267,6 +273,24 @@
                        const std::set<uint8_t>& tids,
                        const std::set<uint8_t>& linkIds);
 
+    /**
+     * Block or unblock the given set of links for all the container queues for the given reason.
+     *
+     * @param block true to block the queues, false to unblock
+     * @param reason the reason for blocking the queues
+     * @param linkIds set of links to block (empty to block all setup links)
+     */
+    void DoBlockAllQueues(bool block,
+                          WifiQueueBlockedReason reason,
+                          const std::set<uint8_t>& linkIds);
+
+    /**
+     * When it is requested to block all the queues, an entry is added to this map to store the
+     * reason and the IDs of the links to block. This information is used to block queues that
+     * will be created afterwards.
+     */
+    std::map<WifiQueueBlockedReason, std::set<uint8_t>> m_blockAllInfo;
+
     std::vector<PerAcInfo> m_perAcInfo{AC_UNDEF}; //!< vector of per-AC information
     NS_LOG_TEMPLATE_DECLARE;                      //!< the log component
 };
@@ -366,7 +390,19 @@
                 GetMac()->GetWifiRemoteStationManager(linkId)->GetAffiliatedStaAddress(rxAddr))
             {
                 // the mask is not modified if linkId is already in the map
-                queueInfoIt->second.linkIds.emplace(linkId, Mask{});
+                auto [it, inserted] = queueInfoIt->second.linkIds.try_emplace(linkId);
+
+                if (inserted)
+                {
+                    // linkId was not in the map, set the mask if all queues are blocked
+                    for (const auto& [reason, linkIds] : m_blockAllInfo)
+                    {
+                        if (linkIds.contains(linkId))
+                        {
+                            it->second.set(static_cast<std::size_t>(reason), true);
+                        }
+                    }
+                }
             }
             else
             {
@@ -390,7 +426,16 @@
         // is preserved)
         if (linkIdsMap.empty() || linkIdsMap.cbegin()->first != *linkId)
         {
-            linkIdsMap = {{*linkId, Mask{}}};
+            Mask mask;
+            for (const auto& [reason, linkIds] : m_blockAllInfo)
+            {
+                if (linkIds.contains(*linkId))
+                {
+                    mask.set(static_cast<std::size_t>(reason), true);
+                }
+            }
+
+            linkIdsMap = {{*linkId, mask}};
         }
     }
 
@@ -517,7 +562,7 @@
         auto queueInfoIt = InitQueueInfo(ac, Create<WifiMpdu>(Create<Packet>(), hdr));
         for (auto& [linkId, mask] : queueInfoIt->second.linkIds)
         {
-            if (linkIds.empty() || linkIds.count(linkId) > 0)
+            if (linkIds.empty() || linkIds.contains(linkId))
             {
                 mask.set(static_cast<std::size_t>(reason), block);
             }
@@ -554,6 +599,84 @@
 }
 
 template <class Priority, class Compare>
+void
+WifiMacQueueSchedulerImpl<Priority, Compare>::DoBlockAllQueues(bool block,
+                                                               WifiQueueBlockedReason reason,
+                                                               const std::set<uint8_t>& linkIds)
+{
+    for (auto& perAcInfo : m_perAcInfo)
+    {
+        for (auto& [queueId, queueInfo] : perAcInfo.queueInfoMap)
+        {
+            for (auto& [linkId, mask] : queueInfo.linkIds)
+            {
+                if (linkIds.empty() || linkIds.contains(linkId))
+                {
+                    mask.set(static_cast<std::size_t>(reason), block);
+                }
+            }
+        }
+    }
+}
+
+template <class Priority, class Compare>
+void
+WifiMacQueueSchedulerImpl<Priority, Compare>::BlockAllQueues(WifiQueueBlockedReason reason,
+                                                             const std::set<uint8_t>& linkIds)
+{
+    DoBlockAllQueues(true, reason, linkIds);
+
+    if (linkIds.empty())
+    {
+        m_blockAllInfo[reason] = GetMac()->GetLinkIds(); // all links blocked
+    }
+    else
+    {
+        m_blockAllInfo[reason].merge(std::set<uint8_t>{linkIds});
+    }
+}
+
+template <class Priority, class Compare>
+void
+WifiMacQueueSchedulerImpl<Priority, Compare>::UnblockAllQueues(WifiQueueBlockedReason reason,
+                                                               const std::set<uint8_t>& linkIds)
+{
+    DoBlockAllQueues(false, reason, linkIds);
+
+    auto infoIt = m_blockAllInfo.find(reason);
+
+    if (infoIt == m_blockAllInfo.end())
+    {
+        return; // all queues were not blocked for the given reason
+    }
+    std::erase_if(infoIt->second,
+                  [&](uint8_t id) { return linkIds.empty() || linkIds.contains(id); });
+
+    if (infoIt->second.empty())
+    {
+        // no more links blocked for the given reason
+        m_blockAllInfo.erase(infoIt);
+    }
+}
+
+template <class Priority, class Compare>
+bool
+WifiMacQueueSchedulerImpl<Priority, Compare>::GetAllQueuesBlockedOnLink(
+    uint8_t linkId,
+    WifiQueueBlockedReason reason)
+{
+    for (const auto& [r, linkIds] : m_blockAllInfo)
+    {
+        if ((reason == WifiQueueBlockedReason::REASONS_COUNT || reason == r) &&
+            linkIds.contains(linkId))
+        {
+            return true;
+        }
+    }
+    return false;
+}
+
+template <class Priority, class Compare>
 std::optional<WifiMacQueueScheduler::Mask>
 WifiMacQueueSchedulerImpl<Priority, Compare>::GetQueueLinkMask(AcIndex ac,
                                                                const WifiContainerQueueId& queueId,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/wifi-mac-trailer.h ns-3.45/src/wifi/model/wifi-mac-trailer.h
--- ns-3.44/src/wifi/model/wifi-mac-trailer.h	2025-03-09 16:55:49.803372600 -0700
+++ ns-3.45/src/wifi/model/wifi-mac-trailer.h	2025-06-01 20:34:45.628702200 -0700
@@ -9,17 +9,14 @@
 #ifndef WIFI_MAC_TRAILER_H
 #define WIFI_MAC_TRAILER_H
 
+#include "wifi-constants.h"
+
 #include "ns3/trailer.h"
 
 namespace ns3
 {
 
 /**
- * The length in octets of the IEEE 802.11 MAC FCS field
- */
-static const uint16_t WIFI_MAC_FCS_LENGTH = 4;
-
-/**
  * @ingroup wifi
  *
  * Implements the IEEE 802.11 MAC trailer
